#age calculation   # www.Tricks12345.com
from tkinter import *
from tkinter.ttk import *
from tkinter import Tk
import datetime
from tkinter import messagebox

class Agecalculation:
    def __init__(self):
        self.layout = Tk()
        self.layout.geometry('500x500')
        self.layout.title('Age Calculation Application')

        self.labl1 = Label(self.layout, text = 'Select the year', font=("calibri", 15,  "bold"))
        self.labl1.grid(column = 0, row = 0)
        self.combo1 = Combobox(self.layout, width = 25)
        self.combo1.grid(column = 1, row = 0)

        self.labl2 = Label(self.layout, text = 'Select the month', font=("calibri", 15))
        self.labl2.grid(column = 0, row = 1)
        self.combo2 = Combobox(self.layout, width = 25)
        self.combo2.grid(column = 1, row = 1)


        self.labl3 = Label(self.layout, text = 'Select the date', font=("calibri", 15))
        self.labl3.grid(column = 0, row = 2)
        self.combo3 = Combobox(self.layout, width = 25)
        self.combo3.grid(column = 1, row = 2)

        self.labl4 = Label(self.layout, text = 'Enter your Name', font=("calibri", 15))
        self.labl4.grid(column = 0, row = 3)

        self.txtbox = Entry(self.layout, width = 25, font=("calibri", 15))
        self.txtbox.grid(column = 1, row = 3)
        self.txtbox.focus()
        
        self.btn = Button(self.layout, text = 'Clik here to calculate your age', command = self.CalculateAge)
        self.btn.grid(column = 0, row = 4)

    def EnterTheYearsInCombo(self):
        year = []
        t = datetime.date.today()
        y = t.year
        for i in range(200):             
            year.append(y - int(i) )
        self.combo1['values'] = year
        self.combo1.current(0)

    def EnterTheMonthsInCombo(self):
        month = []        
        for m in range(12):
            month.append((int(m)+1))        
        self.combo2['values'] = month
        self.combo2.current(1)

    def EnterTheDaysInCombo(self):
        days = []         
        for d in range(31):
            days.append((int(d)+1))        
        self.combo3['values'] = days
        self.combo3.current(1)

    def CalculateAge(self):
        Dobyear = self.combo1.get()
        Dobmonth = self.combo2.get()
        Dobday = self.combo3.get()
        CurrentDate = datetime.date.today()
        try:
            dob = datetime.date(int(Dobyear),int(Dobmonth),int(Dobday))
            if  dob > CurrentDate:
                raise ValueError
            monthdates = {1:31, 2:28, 3:31, 4:30, 5:31,6:30, 7:31, 8:31, 9:30,10:31, 11:30, 12:31}
            maxdate = monthdates.get(int(Dobmonth))         
            # DOB year less than or equal to current year
            if int(Dobyear) <= (CurrentDate.year):
                yeardiff = (CurrentDate.year) - int(Dobyear)

            # calculation of days difference
            if int(Dobday) <  (CurrentDate.day):
                daydiff = (CurrentDate.day) - int(Dobday)
                m = (CurrentDate.month) 
            elif int(Dobday) >  (CurrentDate.day):
                d = int(Dobday) - (CurrentDate.day)
                daydiff = maxdate - d -1
                m = (CurrentDate.month) -1
            elif int(Dobday) ==  (CurrentDate.day):
                daydiff = 0
                m = (CurrentDate.month)

            # calculation of months difference

            if int(Dobmonth) < m:
                monthdiff = m - int(Dobmonth)    
                
            elif int(Dobmonth) > m:
                monthdiff =   int(Dobmonth) - m
                yeardiff = yeardiff -1
                monthdiff = 12 - monthdiff

            elif int(Dobmonth) == (CurrentDate.month):
                monthdiff =  0             
            
                 
             
            if  monthdiff == 0 and yeardiff == 0:
                Totalage = str(daydiff) + ' days'
            elif   yeardiff ==0:
                  Totalage = str(monthdiff) + ' months ' + str(daydiff) +  ' days'              
            elif   monthdiff ==0:
                  Totalage = str(yeardiff) + ' years ' + str(daydiff) +  ' days'
            elif   daydiff ==0:
                  Totalage = str(yeardiff) + ' years ' + str(monthdiff) +  ' months'
            else:
                Totalage = str(yeardiff) + ' years ' + str(monthdiff) +  ' months ' + str(daydiff) +  ' days'
            print('Total Age =  ' + str(Totalage))

            name = self.txtbox.get()
            messagebox.showinfo('Age Calculator message', 'Hello ' + name + '  Your  Age =  ' + str(Totalage))
        except ValueError:
            print('Date of Birth shouldn\'t exceed current date')    
        self.layout.mainloop()
q = Agecalculation()
q.EnterTheYearsInCombo()
q.EnterTheMonthsInCombo()
q.EnterTheDaysInCombo() 
 
